package com.gyee.runeconomy.service;


import com.gyee.runeconomy.dto.result.PowerPointData;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 散点聚合
 */
public class DBSCANPointALG {

    /**
     * 功率曲线拟合 散点聚合
     * @param points  散点list
     * @param param   聚合参数  10
     * @return
     */
    public static  Map<String, List<PowerPointData>> dbscan(List<PowerPointData> points, double param){
        Map<String, List<PowerPointData>> map = new HashMap<>();

        for (PowerPointData item : points){
            double x = item.getSpeed() * param;
            double y = item.getPower() / param;

            String key = Math.round(x) +  String.valueOf(Math.round(y));

            if (!map.containsKey(key)){
                map.put(key, new ArrayList<>());
            }
            map.get(key).add(item);
        }

        return map;
    }

//    public static  Map<String, List<PhotovoltaicInfo>> dbgfscan(List<PhotovoltaicInfo> points, double param){
//        Map<String, List<PhotovoltaicInfo>> map = new HashMap<>();
//
//        for (PhotovoltaicInfo item : points){
//            double x = item.getS() * param;
//            double y = item.getActualP() / param;
//
//            String key = Math.round(x) +  String.valueOf(Math.round(y));
//
//            if (!map.containsKey(key)){
//                map.put(key, new ArrayList<>());
//            }
//            map.get(key).add(item);
//        }
//
//        return map;
//    }

}
